package com.terraformersmc.terraform.feature;

import com.mojang.datafixers.Dynamic;
import java.util.Random;
import java.util.Set;
import java.util.function.Function;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2541;
import net.minecraft.class_2680;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_2902;
import net.minecraft.class_2944;
import net.minecraft.class_3341;
import net.minecraft.class_3747;
import net.minecraft.class_4643;

public class TerraformSwampTreeFeature extends class_2944<class_4643> {

	public static final class_2680 OAK_LOG = class_2246.field_10431.method_9564();
	public static final class_2680 OAK_LEAVES = class_2246.field_10503.method_9564().method_11657(class_2741.field_12514, false);
	private final int minHeight;
	private class_2680 log;
	private class_2680 leaves;

	public TerraformSwampTreeFeature(Function<Dynamic<?>, ? extends class_4643> configFactory, boolean emitNeighborBlockUpdates) {
		this(configFactory, emitNeighborBlockUpdates, 5);
	}

	public TerraformSwampTreeFeature(Function<Dynamic<?>, ? extends class_4643> configFactory, boolean emitNeighborBlockUpdates, int minHeight) {
		this(configFactory, emitNeighborBlockUpdates, minHeight, OAK_LOG, OAK_LEAVES);
	}

	public TerraformSwampTreeFeature(Function<Dynamic<?>, ? extends class_4643> configFactory, boolean emitNeighborBlockUpdates, int minHeight, class_2680 log, class_2680 leaves) {
		super(configFactory);
		this.minHeight = minHeight;
		this.log = log;
		this.leaves = leaves;
	}

	@Override
	public boolean method_12775(class_3747 world, Random random, class_2338 pos, Set<class_2338> set1, Set<class_2338> set2, class_3341 boundingBox, class_4643 config) {
		int height = random.nextInt(4) + minHeight;
		pos = world.method_8598(class_2902.class_2903.field_13200, pos);
		boolean generate = true;
		if (pos.method_10264() >= 1 && pos.method_10264() + height + 1 <= 256) {
			int y;
			int var10;
			int var11;
			for (y = pos.method_10264(); y <= pos.method_10264() + 1 + height; ++y) {
				int offset = 1;
				if (y == pos.method_10264()) {
					offset = 0;
				}

				if (y >= pos.method_10264() + 1 + height - 2) {
					offset = 3;
				}

				class_2338.class_2339 checking = new class_2338.class_2339();

				for (var10 = pos.method_10263() - offset; var10 <= pos.method_10263() + offset && generate; ++var10) {
					for (var11 = pos.method_10260() - offset; var11 <= pos.method_10260() + offset && generate; ++var11) {
						if (y >= 0 && y < 256) {
							checking.method_10103(var10, y, var11);
							if (!method_16420(world, checking)) {
								if (method_16422(world, checking)) {
									if (y > pos.method_10264()) {
										generate = false;
									}
								} else {
									generate = false;
								}
							}
						} else {
							generate = false;
						}
					}
				}
			}

			if (!generate) {
				return false;
			} else if (method_16430(world, pos.method_10074()) && pos.method_10264() < 256 - height - 1) {
				this.method_16427(world, pos.method_10074());

				int var12;
				class_2338 leavesPos;
				int var17;
				int var18;
				for (y = pos.method_10264() - 3 + height; y <= pos.method_10264() + height; ++y) {
					var17 = y - (pos.method_10264() + height);
					var18 = 2 - var17 / 2;

					for (var10 = pos.method_10263() - var18; var10 <= pos.method_10263() + var18; ++var10) {
						var11 = var10 - pos.method_10263();

						for (var12 = pos.method_10260() - var18; var12 <= pos.method_10260() + var18; ++var12) {
							int var13 = var12 - pos.method_10260();
							if (Math.abs(var11) != var18 || Math.abs(var13) != var18 || random.nextInt(2) != 0 && var17 != 0) {
								leavesPos = new class_2338(var10, y, var12);
								if (method_16420(world, leavesPos) || method_16425(world, leavesPos)) {
									this.method_13153(world, leavesPos, leaves);
								}
							}
						}
					}
				}

				for (y = 0; y < height; ++y) {
					class_2338 logPos = pos.method_10086(y);
					if (method_16420(world, logPos) || method_16422(world, logPos)) {
						this.method_12773(world, logPos, log, boundingBox);
					}
				}

				for (y = pos.method_10264() - 3 + height; y <= pos.method_10264() + height; ++y) {
					var17 = y - (pos.method_10264() + height);
					var18 = 2 - var17 / 2;
					class_2338.class_2339 outerLeavesPos = new class_2338.class_2339();

					for (var11 = pos.method_10263() - var18; var11 <= pos.method_10263() + var18; ++var11) {
						for (var12 = pos.method_10260() - var18; var12 <= pos.method_10260() + var18; ++var12) {
							outerLeavesPos.method_10103(var11, y, var12);
							if (method_16416(world, outerLeavesPos)) {
								class_2338 westPos = outerLeavesPos.method_10067();
								leavesPos = outerLeavesPos.method_10078();
								class_2338 norhtPos = outerLeavesPos.method_10095();
								class_2338 southPos = outerLeavesPos.method_10072();
								if (random.nextInt(4) == 0 && method_16424(world, westPos)) {
									this.addVines(world, westPos, class_2541.field_11702);
								}

								if (random.nextInt(4) == 0 && method_16424(world, leavesPos)) {
									this.addVines(world, leavesPos, class_2541.field_11696);
								}

								if (random.nextInt(4) == 0 && method_16424(world, norhtPos)) {
									this.addVines(world, norhtPos, class_2541.field_11699);
								}

								if (random.nextInt(4) == 0 && method_16424(world, southPos)) {
									this.addVines(world, southPos, class_2541.field_11706);
								}
							}
						}
					}
				}

				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	private void addVines(class_3747 var1, class_2338 var2, class_2746 var3) {
		class_2680 var4 = class_2246.field_10597.method_9564().method_11657(var3, true);
		this.method_13153(var1, var2, var4);
		int var5 = 4;

		for (var2 = var2.method_10074(); method_16424(var1, var2) && var5 > 0; --var5) {
			this.method_13153(var1, var2, var4);
			var2 = var2.method_10074();
		}

	}

}
